package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class SceneEvents_0 extends SceneScript
{
	public var _YVar:Float;
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("Y", "_YVar");
		_YVar = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		/* Issue 1 - Value change FPS drop
It appears that the block below is causing low framerates when there are multiple drawing blocks using it. This was not the case in version 3.4. */
		Actuate.tween(this, 60, {_YVar:-1000}).ease(Linear.easeNone);
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				/* I used the same amount (or more) of drawing blocks in 3.4 without any issue with low framerates.  */
				g.setFont(getFont(0));
				g.drawString("" + (("Y: ") + ("" + Math.round(_YVar))), 4, 4);
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 120));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 140));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 160));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 180));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 200));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 220));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 240));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 260));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 280));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 300));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 320));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 340));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 360));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 380));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 400));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 420));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 440));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 460));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 480));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 500));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 520));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 540));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 560));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 580));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 600));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 620));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 640));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 660));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 680));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 700));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 720));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 740));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 760));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 780));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 800));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 820));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 840));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 860));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 880));
				g.drawString("" + "Issue 1", ((getScreenWidth() / 2) - (g.font.font.getTextWidth("Issue 1", g.font.letterSpacing)/Engine.SCALE / 2)), (_YVar + 900));
			}
		});
		
		/* =========================== On Actor =========================== */
		addMouseOverActorListener(getActor(1), function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 3 == mouseState)
			{
				switchScene(GameModel.get().scenes.get(1).getID(), createFadeOut(0.5, Utils.getColorRGB(0,0,0)), createFadeIn(0.5, Utils.getColorRGB(0,0,0)));
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}